// RW Sumomo's World! Project
// ==========================
// Animated avatars demo project; A pair of cute Chibitsu-grade robowaifus help!

// Filename: ./main_sumomos_world.cpp
// -The program's entry point

#include "incls_all.hpp"

void init_sumomo(Sumomo& sumomo);
void init_kotoko(Kotoko& kotoko);

//------------------------------------------------------------------------------
/**
 */
int main() try {
  puts("\nWakey, wakey world...\n");

  Sumomo sumomo{"Sumomo"};
  init_sumomo(sumomo);
  //
  sumomo.whistle().tweet();

  puts("");

  Kotoko kotoko{"Kotoko"};
  init_kotoko(kotoko);

  ///
  // if (use_stamps)
  //   analyze_callgraph();

  puts("\n...leaving main()\n");

} catch (runtime_error const& e) {
  cerr << "\n" << e.what() << " caught in main()\n\n";

} catch (exception const& e) {
  cerr << "\n" << e.what() << " caught in main()\n\n";

} catch (...) {
  cerr << "\n Unknown error caught in main()\n\n";
}

//------------------------------------------------------------------------------
/**
 */
void init_sumomo(Sumomo& sumomo) {
  sumomo.do_preflight();
  //
  // TODO: create an integrated systems/status terminal suite. mv this there.
  // -status msgs into one terminal, diag spew into another.
  // DIAG:
  prt_tag(sumomo.t());
  prt_tag(sumomo.animeyes().t(), "sumomo.animeyes()");
  prt_tag(sumomo.atashi().t(), "sumomo.atashi()");
  prt_tag(sumomo.bones().t(), "sumomo.bones()");
  prt_tag(sumomo.curator().t(), "sumomo.curator()");
  prt_tag(sumomo.dollhouse().t(), "sumomo.dollhouse()");
  prt_tag(sumomo.electro().t(), "sumomo.electro()");
  prt_tag(sumomo.face().t(), "sumomo.face()");
  prt_tag(sumomo.gears().t(), "sumomo.gears()");
  prt_tag(sumomo.hand().t(), "sumomo.hand()");
  prt_tag(sumomo.hearsay().t(), "sumomo.hearsay()");
  prt_tag(sumomo.meido().t(), "sumomo.meido()");
  prt_tag(sumomo.shell().t(), "sumomo.shell()");

  puts("");

  prt_tag(sumomo.graphicom().t(), "sumomo.graphicom()");

  puts("");

  prt_tag(sumomo.confetti().t(), "sumomo.confetti()");
  prt_tag(sumomo.dustpan().t(), "sumomo.dustpan()");
  prt_tag(sumomo.flags().t(), "sumomo.flags()");
  prt_tag(sumomo.pompoms().t(), "sumomo.pompoms()");
  prt_tag(sumomo.tambourine().t(), "sumomo.tambourine()");
  prt_tag(sumomo.whisk().t(), "sumomo.whisk()");
  prt_tag(sumomo.whistle().t(), "sumomo.whistle()");

  puts("");
}

//------------------------------------------------------------------------------
/**
 */
void init_kotoko(Kotoko& kotoko) {
  kotoko.do_preflight();
  //
  // TODO: create an integrated systems/status terminal suite. mv this there.
  // -status msgs into one terminal, diag spew into another.
  // DIAG:
  prt_tag(kotoko.t());
  prt_tag(kotoko.animeyes().t(), "kotoko.animeyes()");
  prt_tag(kotoko.atashi().t(), "kotoko.atashi()");
  prt_tag(kotoko.bones().t(), "kotoko.bones()");
  prt_tag(kotoko.curator().t(), "kotoko.curator()");
  prt_tag(kotoko.dollhouse().t(), "kotoko.dollhouse()");
  prt_tag(kotoko.electro().t(), "kotoko.electro()");
  prt_tag(kotoko.face().t(), "kotoko.face()");
  prt_tag(kotoko.gears().t(), "kotoko.gears()");
  prt_tag(kotoko.hand().t(), "kotoko.hand()");
  prt_tag(kotoko.hearsay().t(), "kotoko.hearsay()");
  prt_tag(kotoko.meido().t(), "kotoko.meido()");
  prt_tag(kotoko.shell().t(), "kotoko.shell()");

  puts("");

  prt_tag(kotoko.graphicom().t(), "kotoko.graphicom()");

  puts("");
}

//    --=^=--

// "We just needed the pantsu for a parachute!"

// rw_sumomos_world_demo.v220312
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
